'''
Created on 04 Oct 2011

@author: Simon Wilshin

The data stored in our experiment tree can have several 
different names for things like id or children in the tree.
These functions act to inspect metaData and determine what 
portions of that meta data refer to what is desired.
'''

from yaml import load as yamlload
from os.path import join as osjoin

def getID(metaData):
    if metaData.has_key("experimentName"):
        return(metaData["experimentName"])
    elif metaData.has_key("subjectName"):
        return(metaData["subjectName"])
    elif metaData.has_key("subject"):
        return(metaData["subject"])
    elif metaData.has_key("trialName"):
        return(metaData["trialName"])
    elif metaData.has_key("iD"):
        return(metaData["iD"])
    elif metaData.has_key("id"):
        return(metaData["id"])
    elif metaData.has_key("name"):
        return(metaData["name"])
    else:
        return(None)
            
def getChildren(metaData):
    nchildren = []
    if metaData.has_key("children"):
        nchildren.extend(metaData["children"])
    if metaData.has_key("subjects"):
        nchildren.extend(metaData["subjects"])
    if metaData.has_key("trials"):
        nchildren.extend(metaData["trials"])    
    return(nchildren)

def loadMD(path):
    if type(path) == list:
        metaDataFile = osjoin(*path)
    else:
        metaDataFile = path
    stream = file(metaDataFile, 'r')
    metaData=yamlload(stream)
    stream.close()
    return metaData
    
def loadMetaData(key, obj, metaData,default=None):
        if metaData.has_key(key):
            obj.__dict__[key] = metaData[key]
        else:
            obj.__dict__[key] = default