'''
Created on 22 May 2012

@author: aspence
'''

from spiderGaitAblationsTrial import SpiderGaitAblationsTrial
from directoryAware import DirectoryAware

class SpiderGaitAblationsSubject(DirectoryAware):
    '''
    A subject that has been nerve blocked on a treadmill with mocap
    '''

    def makePlots(self):
        for t in self.trials:
            t.spiderTarsiTrackData.makePlots()
    
    def __init__(self,workingDirectory, analysisDirectory, metaData):
        '''
        Constructor, this object knows about directories, weighs the subject using available 
        data and processes the relevant trials
        '''
        print "\nProcessing Subject " + metaData["subject"]
        DirectoryAware.__init__(self, workingDirectory,analysisDirectory,metaData)
        self.trials=[SpiderGaitAblationsTrial(self.workingDirectory, self.analysisDirectory, md) for md in metaData["trials"]]
        self.name = metaData["subject"]