'''
Created on 4 Feb 2011

@author: swilshin
'''

#from scipy.stats.stats import nanmean
from numpy import nanmean
import numpy as np

from interpolation import nanInterpolation
from peakDetection import getPeak
from filters import ButterFilter

def filteredAbsFourierTransform(signal,sampleRate,lowCutoffFrequency,highCutoffFrequency,filterOrder):
        if len(signal)==0:
            return(signal) # Fourier transform of nothing is nothing
        # Filtering
        lpbf=ButterFilter(float(sampleRate),highCutoffFrequency,filterOrder,'lowpass')
        hpbf=ButterFilter(float(sampleRate),lowCutoffFrequency,filterOrder,'highpass')
        signal=nanInterpolation(signal)
        filteredSignal=lpbf.filter(signal)
        filteredSignal=hpbf.filter(filteredSignal)        
        filteredSignal-=nanmean(filteredSignal)
        # Fourier transform, find peaks by solving a quadratic at highest point in ft 
        return(np.abs(np.fft.rfft(filteredSignal)))

def inferPeakFrequency(signal,sampleRate,lowCutoffFrequency,highCutoffFrequency,filterOrder):    
        fourierTransformedFilteredStrideSignal=filteredAbsFourierTransform(signal,sampleRate,lowCutoffFrequency,highCutoffFrequency,filterOrder)
        return(getPeak(fourierTransformedFilteredStrideSignal,sampleRate))    
