'''
Created on 8 Mar 2011

@author: swilshin
'''



from csv import reader
from os.path import join as osjoin
from copy import deepcopy

from yaml import dump as yamldump


from utils import toStringWithZeros

def writeHDSheepYAML(definition,outfile):
    sheep=None
    id=0
    #trialMultiplier=1000
    yamlDict=dict()
    yamlDict["analysisDir"]="analysis"
    yamlDict["experimentName"]="Huntingdons Sheep"
    yamlDict["workingDir"]="data"
    yamlDict["subjects"]=[]
    subjects=yamlDict["subjects"]
    newSubject=dict()
    for row in definition:
        if row[0]!="Sheep":
            if sheep!="S"+str(row[0]):
                if sheep!=None:
                    subjects.append(deepcopy(newSubject))
                sheep="S"+str(row[0])
                print sheep
                fn=row[2]
                newSubject={"analysisDir":deepcopy(sheep), "subject":deepcopy(sheep), "huntingdonsStatus":{"huntingdonsStatus": row[3]}}
                newRawWeight={"analysisDir":"weight", "rawWeight": None}
                newWeightData={"rawWeight": deepcopy(newRawWeight), "weighMethod": "raw"}
                newSubject["weightData"]=deepcopy(newWeightData)
                trials=list()
                newSubject["trials"]=trials
            taus=row[4].split(" - ")
            print taus
            newMCD={"fileName": deepcopy(fn),
                    "strideFrequencyEstimate": 2, 
                    "minFrequencyOfInterestMultiplier": 0.4, "zeroToNan": True
                   }
            trials.append({"analysisDir":deepcopy(fn[:-4]), "id":deepcopy(id),"motionCaptureData":deepcopy(newMCD), "trialType" : "overground"})
            id+=1
    subjects.append(deepcopy(newSubject))
    print yamlDict
    yamldump(yamlDict, outfile)  

def writeDogGaitTransYAMLFull(definition,outfile):
    dog=None
    id=0
    #trialMultiplier=1000
    yamlDict=dict()
    yamlDict["analysisDir"]="analysis"
    yamlDict["experimentName"]="Dogs Gait Transitions"
    yamlDict["workingDir"]="."
    yamlDict["subjects"]=[]
    subjects=yamlDict["subjects"]
    newSubject=dict()
    for row in definition:
        if row[0]=="Dog":
            transTypes=row[3:]
        else:
            if dog!=row[0]:
                if dog!=None:
                    subjects.append(deepcopy(newSubject))
                dog=row[0]
                print dog
                if dog=="Zack":
                    wd="gaitTrans07022011"
                    fn="zack_07022011_"
                elif dog=="Oliver":
                    wd="gaitTrans20110224_0"
                    fn="gaitTrans2110224_0_trial"
                elif dog=="Quinn":
                    wd="gaitTrans20110228"
                    fn="gaitTrans20110228_trial_"
                elif dog=="Eddie":
                    wd="gaitTrans24032011_0"
                    fn="gaitTrans20110324_0_"
                elif dog=="Billy":
                    wd="gaitTrans24032011_1"
                    fn="gaitTrans20110324_1_"
                elif dog=="Norman":
                    wd="gaitTrans25012011"
                    fn="gaitTransTest25012011"
                elif dog=="Lucas":
                    wd="gaitTrans25022011"
                    fn="gaitTrans20110225_1_trial_"                                        
                newSubject={"analysisDir":deepcopy(dog), "subject":deepcopy(dog), "workingDir": deepcopy(wd)}
                newRawWeight={"analysisDir":"weight", "workingDir":".", "rawWeight": None}
                newWeightData={"rawWeight": deepcopy(newRawWeight), "weighMethod": "raw"}
                newSubject["weightData"]=deepcopy(newWeightData)
                trials=list()
                newSubject["trials"]=trials
            for r,idx in zip(transTypes,range(len(transTypes))):
                if row[idx+3]!='':
                    taus=row[idx+3].split(" - ")
                    print row[idx+3]
                    newMCD={"analysisDir": ".", "fileName": deepcopy(fn+toStringWithZeros(row[2],4)+"_an_"+taus[0]+"to"+taus[1]+".tsv"),
                            "strideFrequencyEstimate": 2, "workingDir": ".", 
                            "minFrequencyOfInterestMultiplier": 0.4, "zeroToNan": True, "beltSpeedThreshold": 0.95, "footOnOffThreshold": 0.95, "tmillDir": [-1, 0, 0]
                           }
                    trials.append({"analysisDir":deepcopy(wd), "id":deepcopy(id),"motionCaptureData":deepcopy(newMCD), "trialType" : "treadmill", "workingDir": ".", "gaitTransition":{"transitionType": r}})
                    id+=1
    subjects.append(deepcopy(newSubject))
    print yamlDict
    yamldump(yamlDict, outfile)

def writeDogGaitTransYAML(definition,outfile):
    dog=None
    id=0
    #trialMultiplier=1000
    yamlDict=dict()
    yamlDict["analysisDir"]="analysis"
    yamlDict["experimentName"]="Dogs Gait Transitions"
    yamlDict["workingDir"]="."
    yamlDict["subjects"]=[]
    subjects=yamlDict["subjects"]
    newSubject=dict()
    for row in definition:
        if row[0]!="Dog":
            if dog!=row[0]:
                if dog!=None:
                    subjects.append(deepcopy(newSubject))
                dog=row[0]
                print dog
                if dog=="Zack":
                    wd="gaitTrans07022011"
                    fn="zack_07022011_"
                elif dog=="Oliver":
                    wd="gaitTrans20110224_0"
                    fn="gaitTrans2110224_0_trial"                    
                newSubject={"analysisDir":deepcopy(dog), "subject":deepcopy(dog), "workingDir": deepcopy(wd)}
                newRawWeight={"analysisDir":"weight", "workingDir":".", "rawWeight": None}
                newWeightData={"rawWeight": deepcopy(newRawWeight), "weighMethod": "raw"}
                newSubject["weightData"]=deepcopy(newWeightData)
                trials=list()
                newSubject["trials"]=trials
            taus=row[4].split(" - ")
            print taus
            newMCD={"analysisDir": ".", "fileName": deepcopy(fn+toStringWithZeros(row[2],4)+"_an_"+taus[0]+"to"+taus[1]+".tsv"),
                    "strideFrequencyEstimate": 2, "workingDir": ".", 
                    "minFrequencyOfInterestMultiplier": 0.4, "zeroToNan": True
                   }
            trials.append({"analysisDir":deepcopy(wd), "id":deepcopy(id),"motionCaptureData":deepcopy(newMCD), "trialType" : "treadmill", "workingDir": ".", "gaitTransition":{"transitionType": row[3]}})
            id+=1
    subjects.append(deepcopy(newSubject))
    print yamlDict
    yamldump(yamlDict, outfile)

if __name__=='__main__':
    '''
    fn=osjoin("..","..","..","..","Documents","data","rawData","gaitTrans","dogs_gaitTrans.csv")
    ofn=osjoin("..","..","..","..","Documents","data","rawData","gaitTrans","dogs_gaitTrans.yaml")
    of=open(ofn,'wb')
    nr=reader(open(fn,'rb'),delimiter=",")
    writeDogGaitTransYAMLFull(nr,of)
    '''
    fn=osjoin("..","..","..","..","Documents","data","rawData","hDSheep","sheepRuns.csv")
    ofn=osjoin("..","..","..","..","Documents","data","rawData","hDSheep","fullHDSheep.yaml")
    of=open(ofn,'wb')
    nr=reader(open(fn,'rb'),delimiter=",")
    writeHDSheepYAML(nr,of)
        